Index: /code/branches/bigships/src/orxonox/gametypes/Dynamicmatch.cc
===================================================================
--- /code/branches/bigships/src/orxonox/gametypes/Dynamicmatch.cc	(revision 8587)
+++ /code/branches/bigships/src/orxonox/gametypes/Dynamicmatch.cc	(revision 8588)
@@ -151,5 +151,5 @@
                 //Give new pig boost
                 SpaceShip* spaceship = dynamic_cast<SpaceShip*>(victim);
-				grantPigBoost(spaceship);
+                grantPigBoost(spaceship);
             }
 
@@ -306,7 +306,7 @@
     }
 
-	void Dynamicmatch::grantPigBoost(orxonox::SpaceShip* spaceship)
-	{
-		// Give pig boost
+    void Dynamicmatch::grantPigBoost(orxonox::SpaceShip* spaceship)
+    {
+        // Give pig boost
         if (spaceship)
         {
@@ -317,5 +317,5 @@
             new Timer(10, false, executor, true);
         }
-	}
+    }
 
     void Dynamicmatch::playerStartsControllingPawn(PlayerInfo* player, Pawn* pawn) //set party + colouring
Index: /code/branches/bigships/src/orxonox/gametypes/Dynamicmatch.h
===================================================================
--- /code/branches/bigships/src/orxonox/gametypes/Dynamicmatch.h	(revision 8587)
+++ /code/branches/bigships/src/orxonox/gametypes/Dynamicmatch.h	(revision 8588)
@@ -73,5 +73,5 @@
             virtual void furtherInstructions();*/
             virtual void rewardPig();
-			void grantPigBoost(SpaceShip* spaceship); // Added this, since it's used twice on different occasions.
+            void grantPigBoost(SpaceShip* spaceship); // Added this, since it's used twice on different occasions.
             void resetSpeedFactor(WeakPtr<SpaceShip>* ptr);
             void tick (float dt);// used to end the game
Index: /code/branches/bigships/src/orxonox/items/Engine.cc
===================================================================
--- /code/branches/bigships/src/orxonox/items/Engine.cc	(revision 8587)
+++ /code/branches/bigships/src/orxonox/items/Engine.cc	(revision 8588)
@@ -47,5 +47,5 @@
         this->ship_ = 0;
         this->shipID_ = OBJECTID_UNKNOWN;
-		this->relativePosition_ = Vector3(0,0,0);
+        this->relativePosition_ = Vector3(0,0,0);
 
         this->boostFactor_ = 1.5;
@@ -72,11 +72,5 @@
     Engine::~Engine()
     {
-        if (this->isInitialized() && this->ship_)
-        {
-            //this->ship_->setEngine(0);
-
-            //if (this->boostBlur_)
-            //    this->boostBlur_->destroy();
-        }
+
     }
 
@@ -98,6 +92,6 @@
         XMLPortParam(Engine, "accelerationupdown",    setAccelerationUpDown,    setAccelerationUpDown,    xmlelement, mode);
 
-		XMLPortParam(Engine, "position", setRelativePosition, getRelativePosition, xmlelement, mode);
-		XMLPortParam(Engine, "template", setEngineTemplate, getEngineTemplate, xmlelement, mode);
+        XMLPortParam(Engine, "position", setRelativePosition, getRelativePosition, xmlelement, mode);
+        XMLPortParam(Engine, "template", setEngineTemplate, getEngineTemplate, xmlelement, mode);
     }
 
@@ -199,15 +193,14 @@
         }
 
-		// NOTE: Bullet always uses global coordinates.
+        // NOTE: Bullet always uses global coordinates.
         this->ship_->addAcceleration(this->ship_->getOrientation() * (acceleration*this->getSpeedMultiply()+Vector3(0,0,-this->getSpeedAdd())), this->ship_->getOrientation() * this->relativePosition_);
 
-
-		// Hack to reset a temporary variable "direction"
-		this->ship_->oneEngineTickDone();
-		if(!this->ship_->hasEngineTicksRemaining())
-		{
-			this->ship_->setSteeringDirection(Vector3::ZERO);
-			this->ship_->resetEngineTicks();
-		}
+        // Hack to reset a temporary variable "direction"
+        this->ship_->oneEngineTickDone();
+        if(!this->ship_->hasEngineTicksRemaining())
+        {
+            this->ship_->setSteeringDirection(Vector3::ZERO);
+            this->ship_->resetEngineTicks();
+        }
     }
 
@@ -247,15 +240,15 @@
     }
 
-	void Engine::loadEngineTemplate()
-	{
-		if(!this->engineTemplate_.empty())
-		{
-			COUT(4)<<"Loading an engine template: "<<this->engineTemplate_<<"\n";
-			Template *temp = Template::getTemplate(this->engineTemplate_);
-			if(temp)
-			{
-				this->addTemplate(temp);
-			}
-		}
-	}
+    void Engine::loadEngineTemplate()
+    {
+        if(!this->engineTemplate_.empty())
+        {
+            COUT(4)<<"Loading an engine template: "<<this->engineTemplate_<<"\n";
+            Template *temp = Template::getTemplate(this->engineTemplate_);
+            if(temp)
+            {
+                this->addTemplate(temp);
+            }
+        }
+    }
 }
Index: /code/branches/bigships/src/orxonox/items/Engine.h
===================================================================
--- /code/branches/bigships/src/orxonox/items/Engine.h	(revision 8587)
+++ /code/branches/bigships/src/orxonox/items/Engine.h	(revision 8588)
@@ -55,8 +55,8 @@
                 { return this->ship_; }
 
-			inline void setRelativePosition(const Vector3 &position)
-				{ this->relativePosition_ = position; }
-			inline Vector3& getRelativePosition()
-				{ return this->relativePosition_; }
+            inline void setRelativePosition(const Vector3 &position)
+                { this->relativePosition_ = position; }
+            inline Vector3& getRelativePosition()
+                { return this->relativePosition_; }
 
             inline void setBoostFactor(float factor)
@@ -124,5 +124,5 @@
                 { this->speedMultiply_=speedMultiply; }
 
-			
+            
             inline void setEngineTemplate(const std::string& temp)
                 { this->engineTemplate_ = temp; this->loadEngineTemplate(); }
@@ -134,5 +134,5 @@
                 { return new std::vector<PickupCarrier*>(); }
             virtual PickupCarrier* getCarrierParent(void) const;
-			
+            
             void loadEngineTemplate();
 
@@ -141,9 +141,9 @@
             void networkcallback_shipID();
 
-			std::string engineTemplate_;
+            std::string engineTemplate_;
 
             SpaceShip* ship_;
             unsigned int shipID_;
-			Vector3 relativePosition_;
+            Vector3 relativePosition_;
 
             float boostFactor_;
Index: /code/branches/bigships/src/orxonox/worldentities/MobileEntity.cc
===================================================================
--- /code/branches/bigships/src/orxonox/worldentities/MobileEntity.cc	(revision 8587)
+++ /code/branches/bigships/src/orxonox/worldentities/MobileEntity.cc	(revision 8588)
@@ -143,19 +143,19 @@
     {
         if (this->isDynamic())
-		{
+        {
             this->physicalBody_->applyCentralForce(btVector3(acceleration.x * this->getMass(), acceleration.y * this->getMass(), acceleration.z * this->getMass()));
-		}
-
-		// If not bullet-managed (deprecated? SpaceShip doesn't use this anymore for movement)
+        }
+
+        // If not bullet-managed (deprecated? SpaceShip doesn't use this anymore for movement)
         this->linearAcceleration_ = acceleration;
     }
 
-	void MobileEntity::addAcceleration(const Vector3 &acceleration, const Vector3 &relativePosition)
-	{
-		if(this->isDynamic())
-		{
-			this->physicalBody_->applyForce(this->getMass() * btVector3(acceleration.x, acceleration.y, acceleration.z), btVector3(relativePosition.x, relativePosition.y, relativePosition.z));
-		}
-	}
+    void MobileEntity::addAcceleration(const Vector3 &acceleration, const Vector3 &relativePosition)
+    {
+        if(this->isDynamic())
+        {
+            this->physicalBody_->applyForce(this->getMass() * btVector3(acceleration.x, acceleration.y, acceleration.z), btVector3(relativePosition.x, relativePosition.y, relativePosition.z));
+        }
+    }
 
     void MobileEntity::setAngularAcceleration(const Vector3& acceleration)
Index: /code/branches/bigships/src/orxonox/worldentities/MobileEntity.h
===================================================================
--- /code/branches/bigships/src/orxonox/worldentities/MobileEntity.h	(revision 8587)
+++ /code/branches/bigships/src/orxonox/worldentities/MobileEntity.h	(revision 8588)
@@ -70,9 +70,9 @@
                 { return this->linearAcceleration_; }
 
-			// Added for making N engines work with spaceships
-			void addAcceleration(const Vector3& acceleration, const Vector3 &relativePosition);
-			inline void addAcceleration(float x, float y, float z)
-				{ this->addAcceleration(Vector3(x, y, z), Vector3(0,0,0)); }
-			// Getter function above
+            // Added for making N engines work with spaceships
+            void addAcceleration(const Vector3& acceleration, const Vector3 &relativePosition);
+            inline void addAcceleration(float x, float y, float z)
+                { this->addAcceleration(Vector3(x, y, z), Vector3(0,0,0)); }
+            // Getter function above
 
             void setAngularAcceleration(const Vector3& acceleration);
Index: /code/branches/bigships/src/orxonox/worldentities/pawns/SpaceShip.cc
===================================================================
--- /code/branches/bigships/src/orxonox/worldentities/pawns/SpaceShip.cc	(revision 8587)
+++ /code/branches/bigships/src/orxonox/worldentities/pawns/SpaceShip.cc	(revision 8588)
@@ -77,5 +77,5 @@
         this->enableCollisionCallback();
 
-		this->engineTicksNotDone = 0;
+        this->engineTicksNotDone = 0;
         this->setConfigValues();
         this->registerVariables();
@@ -87,5 +87,5 @@
         {
             this->removeAllEngines();
-		
+        
             if (this->boostBlur_)
                 this->boostBlur_->destroy();
@@ -106,5 +106,5 @@
         XMLPortParamVariable(SpaceShip, "boostCooldownDuration", boostCooldownDuration_, xmlelement, mode);
 
-		XMLPortObject(SpaceShip, Engine, "engines", addEngine, getEngine, xmlelement, mode);
+        XMLPortObject(SpaceShip, Engine, "engines", addEngine, getEngine, xmlelement, mode);
     }
 
@@ -123,5 +123,5 @@
     {
         SetConfigValue(bInvertYAxis_, false).description("Set this to true for joystick-like mouse behaviour (mouse up = ship down).");
-		
+        
         SetConfigValueExternal(bEnableMotionBlur_, "GraphicsSettings", "enableMotionBlur", true)
             .description("Enable or disable the motion blur effect when moving very fast")
@@ -149,5 +149,5 @@
         if (this->hasLocalController())
         {
-			// Handle mouse look
+            // Handle mouse look
             if (!this->isInMouseLook())
             {
@@ -157,10 +157,10 @@
             this->localAngularAcceleration_.setValue(0, 0, 0);
 
-			// Charge boostPower
+            // Charge boostPower
             if(!this->bBoostCooldown_ && this->boostPower_ < this->initialBoostPower_)
             {
                 this->boostPower_ += this->boostPowerRate_*dt;
             }
-			// Use boostPower
+            // Use boostPower
             if(this->bBoost_)
             {
@@ -174,24 +174,24 @@
             }
 
-			// Enable Blur depending on settings
-			if (this->bEnableMotionBlur_ && !this->boostBlur_ && this->hasLocalController() && this->hasHumanController())
-			{
-				this->boostBlur_ = new Shader(this->getScene()->getSceneManager());
-				this->boostBlur_->setCompositorName("Radial Blur");
-			}
-
-			if (this->boostBlur_) // && this->maxSpeedFront_ != 0 && this->boostFactor_ != 1)
-			{
-				// TODO: this->maxSpeedFront_ gets fastest engine
-				float blur = this->blurStrength_ * clamp((-this->getLocalVelocity().z - 0.0f /*this->maxSpeedFront_*/) / ((150.0f /*boostFactor_*/ - 1) * 1.5f /*this->maxSpeedFront_*/), 0.0f, 1.0f);
-
-				// Show and hide blur effect depending on state of booster
-				if(this->bBoost_)
-					this->boostBlur_->setVisible(blur > 0);
-				else
-					this->boostBlur_->setVisible(false);
-
-				this->boostBlur_->setParameter(0, 0, "sampleStrength", blur);
-			}
+            // Enable Blur depending on settings
+            if (this->bEnableMotionBlur_ && !this->boostBlur_ && this->hasLocalController() && this->hasHumanController())
+            {
+                this->boostBlur_ = new Shader(this->getScene()->getSceneManager());
+                this->boostBlur_->setCompositorName("Radial Blur");
+            }
+
+            if (this->boostBlur_) // && this->maxSpeedFront_ != 0 && this->boostFactor_ != 1)
+            {
+                // TODO: this->maxSpeedFront_ gets fastest engine
+                float blur = this->blurStrength_ * clamp((-this->getLocalVelocity().z - 0.0f /*this->maxSpeedFront_*/) / ((150.0f /*boostFactor_*/ - 1) * 1.5f /*this->maxSpeedFront_*/), 0.0f, 1.0f);
+
+                // Show and hide blur effect depending on state of booster
+                if(this->bBoost_)
+                    this->boostBlur_->setVisible(blur > 0);
+                else
+                    this->boostBlur_->setVisible(false);
+
+                this->boostBlur_->setParameter(0, 0, "sampleStrength", blur);
+            }
         }
     }
@@ -259,74 +259,74 @@
     }
 
-	void SpaceShip::addEngine(orxonox::Engine* engine)
-	{
-		//COUT(0)<<"Adding an Engine: " << engine << endl;
-		this->engineList_.push_back(engine);
-		engine->addToSpaceShip(this);
-		this->resetEngineTicks();
-	}
-	bool SpaceShip::hasEngine(Engine* engine)
-	{
-		for(unsigned int i=0; i<this->engineList_.size(); i++)
-		{
-			if(this->engineList_[i]==engine)
-				return true;
-		}
-		return false;
-	}
-	Engine* SpaceShip::getEngine(unsigned int i)
-	{
-		if(this->engineList_.size()>=i)
-			return 0;
-		else
-			return this->engineList_[i];
-	}
-	void SpaceShip::removeAllEngines()
-	{
-		for(unsigned int i=0; i<this->engineList_.size(); i++)
-			this->engineList_[i]->~Engine();
-	}
-
-	void SpaceShip::setSpeedFactor(float factor)
-	{
-		for(unsigned int i=0; i<this->engineList_.size(); i++)
-			this->engineList_[i]->setSpeedFactor(factor);
-	}
-	float SpaceShip::getSpeedFactor() // Calculate mean SpeedFactor.
-	{
-		float ret = 0; unsigned int i = 0;
-		for(; i<this->engineList_.size(); i++)
-			ret += this->engineList_[i]->getSpeedFactor();
-		ret /= (float)i;
-		return ret;
-	}
-	float SpaceShip::getMaxSpeedFront()
-	{
-		float ret=0;
-		for(unsigned int i=0; i<this->engineList_.size(); i++)
-		{
-			if(this->engineList_[i]->getMaxSpeedFront() > ret)
-				ret = this->engineList_[i]->getMaxSpeedFront();
-		}
-		return ret;
-	}
-	float SpaceShip::getBoostFactor()
-	{
-		float ret = 0; unsigned int i=0;
-		for(; i<this->engineList_.size(); i++)
-			ret += this->engineList_[i]->getBoostFactor();
-		ret /= (float)i;
-		return ret;
-	}
+    void SpaceShip::addEngine(orxonox::Engine* engine)
+    {
+        //COUT(0)<<"Adding an Engine: " << engine << endl;
+        this->engineList_.push_back(engine);
+        engine->addToSpaceShip(this);
+        this->resetEngineTicks();
+    }
+    bool SpaceShip::hasEngine(Engine* engine)
+    {
+        for(unsigned int i=0; i<this->engineList_.size(); i++)
+        {
+            if(this->engineList_[i]==engine)
+                return true;
+        }
+        return false;
+    }
+    Engine* SpaceShip::getEngine(unsigned int i)
+    {
+        if(this->engineList_.size()>=i)
+            return 0;
+        else
+            return this->engineList_[i];
+    }
+    void SpaceShip::removeAllEngines()
+    {
+        for(unsigned int i=0; i<this->engineList_.size(); i++)
+            this->engineList_[i]->~Engine();
+    }
+
+    void SpaceShip::setSpeedFactor(float factor)
+    {
+        for(unsigned int i=0; i<this->engineList_.size(); i++)
+            this->engineList_[i]->setSpeedFactor(factor);
+    }
+    float SpaceShip::getSpeedFactor() // Calculate mean SpeedFactor.
+    {
+        float ret = 0; unsigned int i = 0;
+        for(; i<this->engineList_.size(); i++)
+            ret += this->engineList_[i]->getSpeedFactor();
+        ret /= (float)i;
+        return ret;
+    }
+    float SpaceShip::getMaxSpeedFront()
+    {
+        float ret=0;
+        for(unsigned int i=0; i<this->engineList_.size(); i++)
+        {
+            if(this->engineList_[i]->getMaxSpeedFront() > ret)
+                ret = this->engineList_[i]->getMaxSpeedFront();
+        }
+        return ret;
+    }
+    float SpaceShip::getBoostFactor()
+    {
+        float ret = 0; unsigned int i=0;
+        for(; i<this->engineList_.size(); i++)
+            ret += this->engineList_[i]->getBoostFactor();
+        ret /= (float)i;
+        return ret;
+    }
 
     std::vector<PickupCarrier*>* SpaceShip::getCarrierChildren(void) const
     {
         std::vector<PickupCarrier*>* list = new std::vector<PickupCarrier*>();
-		for(unsigned int i=0; i<this->engineList_.size(); i++)
-			list->push_back(this->engineList_[i]);
+        for(unsigned int i=0; i<this->engineList_.size(); i++)
+            list->push_back(this->engineList_[i]);
         return list;
     }
-	
-	void SpaceShip::changedEnableMotionBlur()
+    
+    void SpaceShip::changedEnableMotionBlur()
     {
         if (!this->bEnableMotionBlur_)
Index: /code/branches/bigships/src/orxonox/worldentities/pawns/SpaceShip.h
===================================================================
--- /code/branches/bigships/src/orxonox/worldentities/pawns/SpaceShip.h	(revision 8587)
+++ /code/branches/bigships/src/orxonox/worldentities/pawns/SpaceShip.h	(revision 8588)
@@ -61,15 +61,15 @@
             virtual void boost(bool bBoost); // Starts or stops boosting.
 
-			void addEngine(Engine* engine);
-			bool hasEngine(Engine* engine);
-			Engine* getEngine(unsigned int i); // This one's for XMLPort
-			inline const std::vector<Engine*>& getEngineList()
-				{ return this->engineList_; }
-			void removeAllEngines();
+            void addEngine(Engine* engine);
+            bool hasEngine(Engine* engine);
+            Engine* getEngine(unsigned int i); // This one's for XMLPort
+            inline const std::vector<Engine*>& getEngineList()
+                { return this->engineList_; }
+            void removeAllEngines();
 
-			void setSpeedFactor(float factor);
-			float getSpeedFactor(); // Gets mean speed factor
-			float getMaxSpeedFront(); // gets largest speed forward
-			float getBoostFactor(); // gets mean boost factor
+            void setSpeedFactor(float factor);
+            float getSpeedFactor(); // Gets mean speed factor
+            float getMaxSpeedFront(); // gets largest speed forward
+            float getBoostFactor(); // gets mean boost factor
 
             inline void setSteeringDirection(const Vector3& direction)
@@ -77,10 +77,10 @@
             inline const Vector3& getSteeringDirection() const
                 { return this->steering_; }
-			inline void resetEngineTicks()
-				{ this->engineTicksNotDone = this->engineList_.size(); }
-			inline void oneEngineTickDone()
-				{ this->engineTicksNotDone--; }
-			inline const bool hasEngineTicksRemaining()
-				{ return (this->engineTicksNotDone>0); }
+            inline void resetEngineTicks()
+                { this->engineTicksNotDone = this->engineList_.size(); }
+            inline void oneEngineTickDone()
+                { this->engineTicksNotDone--; }
+            inline const bool hasEngineTicksRemaining()
+                { return (this->engineTicksNotDone>0); }
 
             inline bool getBoost() const
@@ -109,14 +109,14 @@
             virtual bool isCollisionTypeLegal(WorldEntity::CollisionType type) const;
             
-			//All things booster
-			void changedEnableMotionBlur();
+            //All things booster
+            void changedEnableMotionBlur();
             void boostCooledDown(void);
 
-			Shader* boostBlur_;
+            Shader* boostBlur_;
             float blurStrength_;
             bool bEnableMotionBlur_;
 
-			std::vector<Engine*> engineList_;
-			int engineTicksNotDone; // Used for knowing when to reset temporary variables.
+            std::vector<Engine*> engineList_;
+            int engineTicksNotDone; // Used for knowing when to reset temporary variables.
             Timer timer_;
     };