Index: code/branches/presentation/data/levels/pirateAttack.oxw
===================================================================
--- code/branches/presentation/data/levels/pirateAttack.oxw	(revision 8637)
+++ code/branches/presentation/data/levels/pirateAttack.oxw	(revision 8642)
@@ -9,5 +9,4 @@
   include("stats.oxo")
   include("templates/spaceshipAssff.oxt")
-  include("templates/spaceshipHXYSL.oxt")
   include("templates/spaceshipPirate.oxt")
   include("templates/lodInformation.oxt")
Index: code/branches/presentation/data/levels/pong.oxw
===================================================================
--- code/branches/presentation/data/levels/pong.oxw	(revision 8637)
+++ code/branches/presentation/data/levels/pong.oxw	(revision 8642)
@@ -15,5 +15,5 @@
   <PongBat>
     <camerapositions>
-      <CameraPosition position="0,200,0" pitch=-90 absolute=true />
+      <CameraPosition position="0,150,0" pitch=-90 absolute=true />
       <CameraPosition position="0,50,160" drag=true mouselook=true />
       <CameraPosition position="0,40,125" drag=true mouselook=true />
@@ -58,5 +58,5 @@
   <?lua include("includes/notifications.oxi") ?>
 
-  <WorldAmbientSound source="mainmenu.ogg" playOnLoad=true />
+  <WorldAmbientSound source="Ganymede.ogg" playOnLoad=true looping=true />
 
   <PongBot />
@@ -68,9 +68,5 @@
     <Light type=directional position="0,0,0" direction="0.253, 0.593, -0.765" diffuse="1.0, 0.9, 0.9, 1.0" specular="1.0, 0.9, 0.9, 1.0" />
 
-    <?lua
-      for i = 1, 10, 1 do
-    ?>
-      <SpawnPoint position="<?lua print(math.random() * 1000 - 500) ?>,<?lua print(math.random() * 1000 - 500) ?>,<?lua print(math.random() * 1000 - 500) ?>" lookat="0,0,0" />
-    <?lua end ?>
+    <SpawnPoint position="991.729, -110.11, 435.404" orientation="0.534038, 0.563456, 0.212168, 0.593553" />
 
     <MovableEntity rotationrate=5 rotationaxis="0,0,1">
Index: code/branches/presentation/data/levels/spaceRace.oxw
===================================================================
--- code/branches/presentation/data/levels/spaceRace.oxw	(revision 8637)
+++ code/branches/presentation/data/levels/spaceRace.oxw	(revision 8642)
@@ -1,9 +1,2 @@
-<?lua
-  include("HUDTemplates3.oxo")
-  include("stats.oxo")
-  include("templates/spaceshipAssff.oxt")
-  include("templates/lodInformation.oxt")
-?>
-
 <LevelInfo
  name = "Space Race"
Index: code/branches/presentation/data/levels/templates/spaceshipHXYSL.oxt
===================================================================
--- code/branches/presentation/data/levels/templates/spaceshipHXYSL.oxt	(revision 8637)
+++ code/branches/presentation/data/levels/templates/spaceshipHXYSL.oxt	(revision 8642)
@@ -40,53 +40,2 @@
   </SpaceShip>
 </Template>
-
-<Template name=spaceshipHXYcameras defaults=0>
-  <SpaceShip>
-    <camerapositions>
-      <CameraPosition position="0,8, 60" drag=true mouselook=true />
-      <CameraPosition position="0,16, 120" drag=true mouselook=true />
-      <CameraPosition position="0,24,180" drag=true mouselook=true />
-      <CameraPosition position="0,60,10" pitch="-80" drag=true mouselook=true />
-    </camerapositions>
-  </SpaceShip>
-</Template>
-
-<Template name=spaceshipHXYengine baseclass=MultiStateEngine>
-  <MultiStateEngine
-   boostfactor    = 6
-
-   speedfront     = 150
-   speedback      =  50
-   speedleftright =  50
-   speedupdown    =  50
-
-   accelerationfront     = 500
-   accelerationbrake     = 500
-   accelerationback      =  125
-   accelerationleftright =  125
-   accelerationupdown    =  125
-  >
-    <EffectContainer condition="idle">
-    </EffectContainer>
-    <EffectContainer condition="not idle">
-
-    </EffectContainer>
-    <EffectContainer condition="normal or brake">
-
-    </EffectContainer>
-    <EffectContainer condition="normal or boost">
-      <Backlight mainstate=activity active=false scale=0.4 name=bltest position=" 2, 0, 20" colour="1, 0.7, 0.1, 1.0" width=10 length=1500 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1" />
-      <Backlight mainstate=activity active=false scale=0.4 name=bltest position="-2, 0, 20" colour="1, 0.7, 0.1, 1.0" width=10 length=1500 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1" />
-    </EffectContainer>
-    <EffectContainer condition="boost">
-      <Backlight mainstate=activity active=false scale=0.4 name=bltest position=" 2, 0, 20" colour="1, 0.7, 0.1, 0.7" width=25 length=1000 lifetime=1 elements=30 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Examples/Flare" />
-      <Backlight mainstate=activity active=false scale=0.4 name=bltest position="-2, 0, 20" colour="1, 0.7, 0.1, 0.7" width=25 length=1000 lifetime=1 elements=30 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Examples/Flare" />
-    </EffectContainer>
-    <EffectContainer condition="brake">
-      <FadingBillboard mainstate=activity active=false scale=0.3 position=" 2, 0, 20" colour="0.5, 0.0, 0.0, 0.3" material="Examples/Flare" turnontime=0.5 turnofftime=0.5 />
-      <FadingBillboard mainstate=activity active=false scale=0.3 position="-2, 0, 20" colour="0.5, 0.0, 0.0, 0.3" material="Examples/Flare" turnontime=0.5 turnofftime=0.5 />
-      <FadingBillboard mainstate=activity active=false scale=0.15 position=" 2, 0, 20" colour="1.0, 0.0, 0.0, 1.0" material="Flares/backlightflare" turnontime=0.5 turnofftime=0.5 />
-      <FadingBillboard mainstate=activity active=false scale=0.15 position="-2, 0, 20" colour="1.0, 0.0, 0.0, 1.0" material="Flares/backlightflare" turnontime=0.5 turnofftime=0.5 />
-    </EffectContainer>
-  </MultiStateEngine>
-</Template>
Index: code/branches/presentation/data/levels/templates/spaceshipTransporterSL.oxt
===================================================================
--- code/branches/presentation/data/levels/templates/spaceshipTransporterSL.oxt	(revision 8637)
+++ code/branches/presentation/data/levels/templates/spaceshipTransporterSL.oxt	(revision 8642)
@@ -40,54 +40,2 @@
   </SpaceShip>
 </Template>
-
-<Template name=spaceshipTransportercameras defaults=0>
-  <SpaceShip>
-    <camerapositions>
-      <CameraPosition position="0,90,350" drag=true mouselook=true />
-      <CameraPosition position="0,150, 400" drag=true mouselook=true />
-      <CameraPosition position="0,200,550" drag=true mouselook=true />
-      <CameraPosition position="0,120,200" pitch="-80" drag=true mouselook=true />
-    </camerapositions>
-  </SpaceShip>
-</Template>
-
-<Template name=spaceshipTransporterengine baseclass=MultiStateEngine>
-  <MultiStateEngine
-   boostfactor    = 2
-
-   speedfront     = 50
-   speedback      =  10
-   speedleftright =  10
-   speedupdown    =  10
-
-
-   accelerationfront     = 20
-   accelerationbrake     = 20
-   accelerationback      = 10
-   accelerationleftright =  10
-   accelerationupdown    =  10
-  >
-    <EffectContainer condition="idle">
-    </EffectContainer>
-    <EffectContainer condition="not idle">
-
-    </EffectContainer>
-    <EffectContainer condition="normal or brake">
-
-    </EffectContainer>
-    <EffectContainer condition="normal or boost">
-      <Backlight mainstate=activity active=false scale=2 name=bltest position=" 22, -10, 87" colour="1, 0.7, 0.1, 1.0" width=10 length=3000 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1" />
-      <Backlight mainstate=activity active=false scale=2 name=bltest position="-22, -10, 87" colour="1, 0.7, 0.1, 1.0" width=10 length=3000 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1" />
-    </EffectContainer>
-    <EffectContainer condition="boost">
-      <Backlight mainstate=activity active=false scale=3 name=bltest position=" 22, -10, 87" colour="1, 0.7, 0.1, 0.7" width=25 length=2000 lifetime=1 elements=30 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Examples/Flare" />
-      <Backlight mainstate=activity active=false scale=3 name=bltest position="-22, -10, 87" colour="1, 0.7, 0.1, 0.7" width=25 length=2000 lifetime=1 elements=30 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Examples/Flare" />
-    </EffectContainer>
-    <EffectContainer condition="brake">
-      <FadingBillboard mainstate=activity active=false scale=2 position=" 22, -10, 87" colour="0.5, 0.0, 0.0, 0.3" material="Examples/Flare" turnontime=0.5 turnofftime=0.5 />
-      <FadingBillboard mainstate=activity active=false scale=2 position="-22, -10, 87" colour="0.5, 0.0, 0.0, 0.3" material="Examples/Flare" turnontime=0.5 turnofftime=0.5 />
-      <FadingBillboard mainstate=activity active=false scale=1 position="22, -10, 87" colour="1.0, 0.0, 0.0, 1.0" material="Flares/backlightflare" turnontime=0.5 turnofftime=0.5 />
-      <FadingBillboard mainstate=activity active=false scale=1 position="-22, -10, 87" colour="1.0, 0.0, 0.0, 1.0" material="Flares/backlightflare" turnontime=0.5 turnofftime=0.5 />
-    </EffectContainer>
-  </MultiStateEngine>
-</Template>