Index: code/branches/unity_build/src/libraries/tools/Shader.h
===================================================================
--- code/branches/unity_build/src/libraries/tools/Shader.h	(revision 8672)
+++ code/branches/unity_build/src/libraries/tools/Shader.h	(revision 8674)
@@ -32,12 +32,9 @@
 #include "tools/ToolsPrereqs.h"
 
-#include <map>
+#include <list>
 #include <string>
-#include <vector>
-
 #include <OgreCompositorInstance.h>
 
 #include "util/MultiType.h"
-#include "util/OgreForwardRefs.h"
 #include "core/ViewportEventListener.h"
 
Index: code/branches/unity_build/src/libraries/tools/Timer.cc
===================================================================
--- code/branches/unity_build/src/libraries/tools/Timer.cc	(revision 8672)
+++ code/branches/unity_build/src/libraries/tools/Timer.cc	(revision 8674)
@@ -42,4 +42,5 @@
 #include "core/command/ConsoleCommand.h"
 #include "core/command/CommandExecutor.h"
+#include "core/command/Executor.h"
 #include "core/command/Functor.h"
 #include "tools/interfaces/TimeFactorListener.h"
@@ -175,4 +176,24 @@
     {
         return TimeFactorListener::getTimeFactor();
+    }
+
+    /**
+        @brief Initializes and starts the timer, which will call an executor after some time.
+        @param interval         The timer-interval in seconds
+        @param bLoop            If true, the executor gets called every @a interval seconds
+        @param executor         The executor that will be called
+        @param bKillAfterCall   If true, the timer will be deleted after the executor was called
+    */
+    void Timer::setTimer(float interval, bool bLoop, const ExecutorPtr& executor, bool bKillAfterCall)
+    {
+        this->setInterval(interval);
+        this->bLoop_ = bLoop;
+        this->executor_ = executor;
+        this->bActive_ = true;
+
+        this->time_ = this->interval_;
+        this->bKillAfterCall_ = bKillAfterCall;
+
+        executor->getFunctor()->setSafeMode(true);
     }
 
Index: code/branches/unity_build/src/libraries/tools/Timer.h
===================================================================
--- code/branches/unity_build/src/libraries/tools/Timer.h	(revision 8672)
+++ code/branches/unity_build/src/libraries/tools/Timer.h	(revision 8674)
@@ -80,5 +80,5 @@
 
 #include "core/OrxonoxClass.h"
-#include "core/command/Executor.h"
+#include "core/command/ExecutorPtr.h"
 
 namespace orxonox
@@ -109,23 +109,5 @@
             Timer(float interval, bool bLoop, const ExecutorPtr& executor, bool bKillAfterCall = false);
 
-            /**
-                @brief Initializes and starts the timer, which will call an executor after some time.
-                @param interval         The timer-interval in seconds
-                @param bLoop            If true, the executor gets called every @a interval seconds
-                @param executor         The executor that will be called
-                @param bKillAfterCall   If true, the timer will be deleted after the executor was called
-            */
-            void setTimer(float interval, bool bLoop, const ExecutorPtr& executor, bool bKillAfterCall = false)
-            {
-                this->setInterval(interval);
-                this->bLoop_ = bLoop;
-                this->executor_ = executor;
-                this->bActive_ = true;
-
-                this->time_ = this->interval_;
-                this->bKillAfterCall_ = bKillAfterCall;
-
-                executor->getFunctor()->setSafeMode(true);
-            }
+            void setTimer(float interval, bool bLoop, const ExecutorPtr& executor, bool bKillAfterCall = false);
 
             void run();
Index: code/branches/unity_build/src/modules/pong/PongAI.cc
===================================================================
--- code/branches/unity_build/src/modules/pong/PongAI.cc	(revision 8672)
+++ code/branches/unity_build/src/modules/pong/PongAI.cc	(revision 8674)
@@ -36,4 +36,5 @@
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
+#include "core/command/Executor.h"
 #include "tools/Timer.h"
 
Index: code/branches/unity_build/src/modules/weapons/munitions/ReplenishingMunition.cc
===================================================================
--- code/branches/unity_build/src/modules/weapons/munitions/ReplenishingMunition.cc	(revision 8672)
+++ code/branches/unity_build/src/modules/weapons/munitions/ReplenishingMunition.cc	(revision 8674)
@@ -28,5 +28,7 @@
 
 #include "ReplenishingMunition.h"
+
 #include "core/CoreIncludes.h"
+#include "core/command/Executor.h"
 
 namespace orxonox
Index: code/branches/unity_build/src/modules/weapons/projectiles/LightningGunProjectile.cc
===================================================================
--- code/branches/unity_build/src/modules/weapons/projectiles/LightningGunProjectile.cc	(revision 8672)
+++ code/branches/unity_build/src/modules/weapons/projectiles/LightningGunProjectile.cc	(revision 8674)
@@ -31,4 +31,5 @@
 #include "util/Convert.h"
 #include "core/CoreIncludes.h"
+#include "core/command/Executor.h"
 
 namespace orxonox
Index: code/branches/unity_build/src/orxonox/gametypes/Dynamicmatch.cc
===================================================================
--- code/branches/unity_build/src/orxonox/gametypes/Dynamicmatch.cc	(revision 8672)
+++ code/branches/unity_build/src/orxonox/gametypes/Dynamicmatch.cc	(revision 8674)
@@ -48,4 +48,5 @@
 #include "util/Convert.h"
 #include "core/CoreIncludes.h"
+#include "core/command/Executor.h"
 #include "network/Host.h"
 #include "infos/PlayerInfo.h"
Index: code/branches/unity_build/src/orxonox/weaponsystem/Munition.cc
===================================================================
--- code/branches/unity_build/src/orxonox/weaponsystem/Munition.cc	(revision 8672)
+++ code/branches/unity_build/src/orxonox/weaponsystem/Munition.cc	(revision 8674)
@@ -29,5 +29,7 @@
 
 #include "Munition.h"
+
 #include "core/CoreIncludes.h"
+#include "core/command/Executor.h"
 
 namespace orxonox