Index: branches/terrain/src/lib/graphics/importer/terrain/terrain.cc
===================================================================
--- branches/terrain/src/lib/graphics/importer/terrain/terrain.cc	(revision 8648)
+++ branches/terrain/src/lib/graphics/importer/terrain/terrain.cc	(revision 8684)
@@ -227,7 +227,6 @@
 		}
 	} while ( dirty );
-	printf( "dirtyrounds: %d\n", dirtyRounds );
+	
 	page = activePages;
-	
 	while ( page ) {
 		page->updateTesselation();
@@ -286,7 +285,4 @@
 		}
 		activatedCount = 0; deactivatedCount = 0;
-		//printf( "%d of %d pages drawn\n", pagesX*pagesZ-cullCount, pagesX*pagesZ );
-		//float percentage = (float)cullCount/(float)(pagesX*pagesZ)*100.0f;
-		//printf( "culled %f%% terrain pages away\n",  percentage );
 	}
 	
Index: branches/terrain/src/lib/graphics/importer/terrain/terrain.h
===================================================================
--- branches/terrain/src/lib/graphics/importer/terrain/terrain.h	(revision 8648)
+++ branches/terrain/src/lib/graphics/importer/terrain/terrain.h	(revision 8684)
@@ -233,5 +233,4 @@
 		std::vector<BufferInfo>		buffers;			
 			
-		//Texture					*tex;
 		Triple						cameraPosition;
 		pFrustum					frustum;
Index: branches/terrain/src/lib/graphics/importer/terrain/terrain_page.cc
===================================================================
--- branches/terrain/src/lib/graphics/importer/terrain/terrain_page.cc	(revision 8648)
+++ branches/terrain/src/lib/graphics/importer/terrain/terrain_page.cc	(revision 8684)
@@ -338,5 +338,5 @@
 			addIndex( getIndex( halfStride, 0 ) );
 			addIndex( getIndex( stride, 0 ) );
-			addAgain(  );
+			addAgain( );
 			addIndex( getIndex( 0, stride ) );
 			addIndex( getIndex( stride, halfStride ) );
@@ -352,10 +352,10 @@
 			addIndex( getIndex( halfStride, 0 ) );
 			addIndex( getIndex( 0, 0 ) );
-			addAgain(  );
+			addAgain( );
 			break;
 
 		case ADAPT_T:
 			addIndex( getIndex( stride, stride ) );
-			addAgain(  );
+			addAgain( );
 			addIndex( getIndex( halfStride, stride ) );
 			addIndex( getIndex( stride, 0 ) );
@@ -369,5 +369,5 @@
 			addIndex( getIndex( halfStride, stride ) );
 			addIndex( getIndex( 0, stride ) );
-			addAgain(  );
+			addAgain( );
 			addIndex( getIndex( stride, 0 ) );
 			addIndex( getIndex( 0, halfStride ) );
@@ -392,16 +392,16 @@
 			addIndex( getIndex( halfStride, stride ) );
 			addIndex( getIndex( stride, stride ) );
-			addAgain(  );
+			addAgain( );
 			break;
 
 		case ADAPT_BT:
 			addIndex( getIndex( 0, 0 ) );
-			addAgain(  );
-			addIndex( getIndex( halfStride, 0 ) );
-			addIndex( getIndex( 0, stride ) );
-			addIndex( getIndex( stride, 0 ) );
-			addIndex( getIndex( halfStride, stride ) );
-			addIndex( getIndex( stride, stride ) );
-			addAgain(  );
+			addAgain( );
+			addIndex( getIndex( halfStride, 0 ) );
+			addIndex( getIndex( 0, stride ) );
+			addIndex( getIndex( stride, 0 ) );
+			addIndex( getIndex( halfStride, stride ) );
+			addIndex( getIndex( stride, stride ) );
+			addAgain( );
 			break;
 
@@ -414,5 +414,5 @@
 			addIndex( getIndex( halfStride, stride ) );
 			addIndex( getIndex( stride, stride ) );
-			addAgain(  );
+			addAgain( );
 			break;
 
@@ -425,5 +425,5 @@
 			addIndex( getIndex( halfStride, 0 ) );
 			addIndex( getIndex( 0, 0 ) );
-			addAgain(  );
+			addAgain( );
 			break;
 
@@ -439,6 +439,4 @@
 			break;
 	}
-	assert( numVertices > 3 );
-
 	assert( numIndices % 2 == 0 );
 }
Index: branches/terrain/src/lib/graphics/importer/terrain/terrain_page.h
===================================================================
--- branches/terrain/src/lib/graphics/importer/terrain/terrain_page.h	(revision 8648)
+++ branches/terrain/src/lib/graphics/importer/terrain/terrain_page.h	(revision 8684)
@@ -225,10 +225,10 @@
 		 * @brief Tesselates one row of the terrain page.
 		 * @param _z 			The z-offset of the row
-		 * @param _xStride 		Determines the step-size horizontally
-		 * @param _zStride		Determines the step-size vertically.
+		 * @param _xStride 		Defines the step-size horizontally
+		 * @param _zStride		Defines the step-size vertically.
+		 * @param _adaptLeft	True if the left neighbor has a coarser
+		 *						tesselation level.		
 		 * @param _adaptRight	True if the right neighbor has a coarser
 		 *						tesselation level.
-		 * @param _adaptLeft	True if the left neighbor has a coarser
-		 *						tesselation level.			
 		 */
 		void tesselateRow( int _z, int _xStride, int _zStride, bool _adaptLeft, bool _adaptRight );