Index: data/pool/images/textures/AUTHORS
===================================================================
--- data/pool/images/textures/AUTHORS	(revision 8698)
+++ data/pool/images/textures/AUTHORS	(revision 8699)
@@ -12,4 +12,5 @@
 babel-wall6b.jpg                            Georges Grondin (cc-by-sa)
 can.png                                     Hagen Seifert
+CentralStructure.png                        Hans Sjökvist
 CockpitGlass.jpg                            Mirko Kaiser
 CockpitNose.jpg                             Mirko Kaiser
@@ -21,4 +22,5 @@
 Dirt.jpg                                    unknown
 dish.jpg                                    Felix Schulthess
+Doors.png                                   Hans Sjökvist
 drone.png                                   unknown
 DuBall1.jpg                                 Rocco Bottani, Massimo Maffioli
@@ -39,4 +41,5 @@
 LightningGun.png                            Joël Smely
 LightningGun-s.png                          Joël Smely
+MainStructure.png                           Hans Sjökvist
 MetalBare.jpg                               Benjamin de Capitani
 MetalBase0020_thumbhuge.jpg                 Benjamin de Capitani
@@ -48,4 +51,5 @@
 OrxonoxRED.png                              unknown
 OrxonoxYELLOW.png                           Reto Grieder
+OuterCompartment.png                        Hans Sjökvist
 pirate.jpg                                  Felix Schulthess
 planet.jpg                                  Felix Schulthess
Index: data/pool/materials/AUTHORS
===================================================================
--- data/pool/materials/AUTHORS	(revision 8698)
+++ data/pool/materials/AUTHORS	(revision 8699)
@@ -43,4 +43,5 @@
 hs-w01s.material                                  Hagen Seifert
 HXY.material                                      Benjamin de Capitani
+HydroHarvester.material                           Hans Sjökvist
 iceplanet.material                                Marian Runo
 Invert.material                                   Fabian Landau?
Index: data/pool/materials/HydroHarvester.material
===================================================================
--- data/pool/materials/HydroHarvester.material	(revision 8699)
+++ data/pool/materials/HydroHarvester.material	(revision 8699)
@@ -0,0 +1,83 @@
+material Harv/MainStructure
+{
+	receive_shadows on
+	technique
+	{
+		pass
+		{
+			ambient 0.700000 0.700000 0.700000 1.000000
+			diffuse 0.640000 0.640000 0.640000 1.000000
+			specular 0.100000 0.100000 0.100000 1.000000 3.750000
+			emissive 0.000000 0.000000 0.000000 1.000000
+			texture_unit
+			{
+				texture MainStructure.png
+				tex_address_mode wrap
+				filtering trilinear
+				colour_op alpha_blend
+			}
+		}
+	}
+}
+material Harv/Doors
+{
+	receive_shadows on
+	technique
+	{
+		pass
+		{
+			ambient 0.500000 0.500000 0.500000 1.000000
+			diffuse 0.640000 0.640000 0.640000 1.000000
+			specular 0.500000 0.500000 0.500000 1.000000 12.500000
+			emissive 0.000000 0.000000 0.000000 1.000000
+			texture_unit
+			{
+				texture Doors.png
+				tex_address_mode wrap
+				filtering trilinear
+				colour_op alpha_blend
+			}
+		}
+	}
+}
+material Harv/CentralStructure
+{
+	receive_shadows on
+	technique
+	{
+		pass
+		{
+			ambient 0.800000 0.800000 0.800000 1.000000
+			diffuse 0.640000 0.640000 0.640000 1.000000
+			specular 0.100000 0.100000 0.100000 1.000000 2.500000
+			emissive 0.000000 0.000000 0.000000 1.000000
+			texture_unit
+			{
+				texture CentralStructure.png
+				tex_address_mode wrap
+				filtering trilinear
+				colour_op alpha_blend
+			}
+		}
+	}
+}
+material OuterCompartments
+{
+	receive_shadows on
+	technique
+	{
+		pass
+		{
+			ambient 0.700000 0.700000 0.700000 1.000000
+			diffuse 0.640000 0.640000 0.640000 1.000000
+			specular 0.035437 0.035437 0.035437 1.000000 3.750000
+			emissive 0.000000 0.000000 0.000000 1.000000
+			texture_unit
+			{
+				texture OuterCompartment.png
+				tex_address_mode wrap
+				filtering trilinear
+			}
+		}
+	}
+}
Index: data/pool/models/AUTHORS
===================================================================
--- data/pool/models/AUTHORS	(revision 8698)
+++ data/pool/models/AUTHORS	(revision 8699)
@@ -25,4 +25,5 @@
 duBall/DuBall1.mesh                           Rocco Bottani, Massimo Maffioli
 duBall/DuBall2.mesh                           Rocco Bottani, Massimo Maffioli
+hydrogenharvester/HydroHarvester.mesh         Hans Sjökvist
 primitives/axes/axes.mesh                     Felix Schulthess
 primitives/cone/Cone.mesh                     Felix Schulthess
Index: data/pool/models/hydrogenharvester/info.xml
===================================================================
--- data/pool/models/hydrogenharvester/info.xml	(revision 8699)
+++ data/pool/models/hydrogenharvester/info.xml	(revision 8699)
@@ -0,0 +1,10 @@
+<info>
+    <name>Hydrogen Harvester</name>
+    <author>Hans Sjökvist</author>
+    <dependency>/materials/HydroHarvester.material</dependency>
+    <dependency>/images/textures/MainStructure.png</dependency>
+    <dependency>/images/textures/CentralStructure.png</dependency>
+    <dependency>/images/textures/Doors.png</dependency>
+    <dependency>/images/textures/OuterCompartment.png</dependency>
+    <screenshot>screenshot.jpg</screenshot>
+</info>